package com.fjhx.victoriatourist.controller.jd;

import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.dynamic.datasource.toolkit.DynamicDataSourceContextHolder;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.common.constant.SourceConstant;
import com.fjhx.item.entity.product.po.ProductInfo;
import com.fjhx.item.service.product.ProductInfoService;
import com.fjhx.victoriatourist.entity.jd.dto.JdOrderSelectDto;
import com.fjhx.victoriatourist.entity.jd.vo.JdOrderDetailsVo;
import com.fjhx.victoriatourist.service.jd.JdOrderDetailsService;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

@RestController
@RequestMapping("/jdOrderEx")
public class JdOrderExController {

    @Resource
    private JdOrderDetailsService jdOrderDetailsService;

    @Resource
    private ProductInfoService productInfoService;


    /**
     * 采购单明细异常列表
     *
     * @author hj
     * @date 2024/1/15 10:09
     */
    @PostMapping("/jdOrderDetailExList")
    public Page<JdOrderDetailsVo> jdOrderDetailExList(@RequestBody JdOrderSelectDto dto) {
        return jdOrderDetailsService.jdOrderDetailExList(dto);
    }


    /**
     * 处理异常
     *
     * @author hj
     * @date 2024/1/15 22:18
     */
    @PostMapping("/dealEx")
    public void dealEx(@RequestBody JdOrderDetailsVo vo) {
        if (ObjectUtil.isNull(vo.getId()) || StrUtil.isBlank(vo.getExHandle())) {
            throw new RuntimeException("参数异常");
        }
        jdOrderDetailsService.dealEx(vo);
    }


    @PostMapping("/productInfoById")
    public List<ProductInfo> productInfo(@RequestBody JdOrderDetailsVo vo) {
        DynamicDataSourceContextHolder.push(SourceConstant.ITEM);

        List<ProductInfo> productInfo = productInfoService.lambdaQuery().eq(ProductInfo::getId, vo.getProductId()).list();
        DynamicDataSourceContextHolder.clear();
        return productInfo;
    }
}
