package com.fjhx.victoriatourist.service.deliver.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.extra.spring.SpringUtil;
import com.alibaba.fastjson2.JSONObject;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.dynamic.datasource.annotation.DSTransactional;
import com.baomidou.dynamic.datasource.toolkit.DynamicDataSourceContextHolder;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.fjhx.common.constant.SourceConstant;
import com.fjhx.common.utils.Assert;
import com.fjhx.item.entity.product.po.ProductInfo;
import com.fjhx.item.service.product.ProductInfoService;
import com.fjhx.kd100.entity.company.po.CompanyInfo;
import com.fjhx.kd100.service.company.CompanyInfoService;
import com.fjhx.kd100.util.KD100Util;
import com.fjhx.purchase.entity.arrival.po.ArrivalDetail;
import com.fjhx.purchase.entity.arrival.vo.ArrivalDetailVo;
import com.fjhx.purchase.entity.deliver.DeliverGoodsDetailsPoVo;
import com.fjhx.purchase.entity.purchase.po.Purchase;
import com.fjhx.purchase.entity.purchase.po.PurchaseDetail;
import com.fjhx.purchase.entity.purchase.vo.PurchaseDetailVo;
import com.fjhx.purchase.entity.purchase.vo.PurchaseVo;
import com.fjhx.purchase.entity.quality.po.QualityDetail;
import com.fjhx.purchase.entity.quality.vo.QualityDetailVo;
import com.fjhx.purchase.mapper.purchase.PurchaseDetailMapper;
import com.fjhx.purchase.service.arrival.ArrivalDetailService;
import com.fjhx.purchase.service.purchase.PurchaseDetailService;
import com.fjhx.purchase.service.purchase.PurchaseService;
import com.fjhx.supply.entity.supplier.po.SupplierInfo;
import com.fjhx.supply.service.supplier.SupplierInfoService;
import com.fjhx.victoriatourist.entity.deliver.dto.DeliverGoodsDto;
import com.fjhx.victoriatourist.entity.deliver.dto.DeliverGoodsSelectDto;
import com.fjhx.victoriatourist.entity.deliver.po.DeliverGoods;
import com.fjhx.victoriatourist.entity.deliver.po.DeliverGoodsDetails;
import com.fjhx.victoriatourist.entity.deliver.vo.DeliverGoodsDetailsVo;
import com.fjhx.victoriatourist.entity.deliver.vo.DeliverGoodsVo;
import com.fjhx.victoriatourist.entity.logistics.po.LogisticsDetails;
import com.fjhx.victoriatourist.entity.logistics.po.LogisticsInfos;
import com.fjhx.victoriatourist.entity.purchase.po.PurchaseBack;
import com.fjhx.victoriatourist.entity.purchase.po.PurchaseBackDetails;
import com.fjhx.victoriatourist.entity.purchase.vo.PurchaseBackDetailsVo;
import com.fjhx.victoriatourist.entity.quality.po.QualityDetails;
import com.fjhx.victoriatourist.mapper.deliver.DeliverGoodsMapper;
import com.fjhx.victoriatourist.service.deliver.DeliverGoodsDetailsService;
import com.fjhx.victoriatourist.service.deliver.DeliverGoodsService;
import com.fjhx.victoriatourist.service.logistics.LogisticsDetailsService;
import com.fjhx.victoriatourist.service.logistics.LogisticsInfosService;
import com.fjhx.victoriatourist.service.purchase.PurchaseBackDetailsService;
import com.fjhx.victoriatourist.service.purchase.PurchaseBackService;
import com.fjhx.victoriatourist.service.quality.QualityDetailsService;
import com.fjhx.wms.entity.arrival.po.ArrivalStockRecordsDetails;
import com.fjhx.wms.entity.stock.po.StockJournal;
import com.fjhx.wms.entity.stock.po.StockJournalDetails;
import com.fjhx.wms.entity.stock.po.StockWaitDetails;
import com.fjhx.wms.entity.stock.vo.StockJournalDetailsVo;
import com.fjhx.wms.service.arrival.ArrivalStockRecordsDetailsService;
import com.fjhx.wms.service.stock.StockJournalDetailsService;
import com.fjhx.wms.service.stock.StockJournalService;
import com.fjhx.wms.service.stock.StockWaitDetailsService;
import com.fjhx.wms.service.stock.StockWaitService;
import com.ruoyi.common.core.domain.BaseIdPo;
import com.ruoyi.common.utils.wrapper.IWrapper;
import com.ruoyi.system.utils.UserUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.function.Function;
import java.util.stream.Collectors;


/**
 * <p>
 * 发货 服务实现类
 * </p>
 *
 * @author
 * @since 2023-04-13
 */
@DS(SourceConstant.VICTORIATOURIST)
@Service
public class DeliverGoodsServiceImpl extends ServiceImpl<DeliverGoodsMapper, DeliverGoods> implements DeliverGoodsService {
    @Autowired
    DeliverGoodsDetailsService deliverGoodsDetailsService;
    @Autowired
    ProductInfoService productInfoService;
    @Autowired
    PurchaseDetailService purchaseDetailService;
    @Autowired
    LogisticsInfosService logisticsInfosService;
    @Autowired
    LogisticsDetailsService logisticsDetailsService;
    @Autowired
    PurchaseService purchaseService;
    @Autowired
    private SupplierInfoService supplierInfoService;
    @Autowired
    private ArrivalDetailService arrivalDetailService;
    @Autowired
    private PurchaseBackDetailsService purchaseBackDetailsService;
    @Autowired
    private PurchaseBackService purchaseBackService;
    @Autowired
    private StockWaitService stockWaitService;
    @Autowired
    private StockWaitDetailsService stockWaitDetailsService;
    @Autowired
    private StockJournalDetailsService stockJournalDetailsService;
    @Autowired
    private StockJournalService stockJournalService;
    @Autowired
    private ArrivalStockRecordsDetailsService arrivalStockRecordsDetailsService;
    @Autowired
    private QualityDetailsService qualityDetailsService;
    @Autowired
    private PurchaseDetailMapper purchaseDetailMapper;
    @Autowired
    private CompanyInfoService companyInfoService;

    @Value("${spring.profiles.active}")
    private String active;


    @Override
    public Page<DeliverGoodsVo> getPage(DeliverGoodsSelectDto dto) {
        IWrapper<DeliverGoods> wrapper = getWrapper();

        wrapper.eq("dg", DeliverGoods::getPurchaseId, dto.getPurchaseId());

        wrapper.orderByDesc("dg", DeliverGoods::getId);
        Page<DeliverGoodsVo> page = this.baseMapper.getPage(dto.getPage(), wrapper);
        List<DeliverGoodsVo> records = page.getRecords();
        if (ObjectUtil.isEmpty(records)) {
            return page;
        }
        setInfo(records);
        return page;
    }

    void setInfo(List<DeliverGoodsVo> lsit) {
        if (ObjectUtil.isEmpty(lsit)) {
            return;
        }

        //赋值物流公司名称
        List<String> companyCode = lsit.stream().map(DeliverGoodsVo::getLogisticsCompanyCode).collect(Collectors.toList());
        List<CompanyInfo> companyInfoList = companyInfoService.list(q -> q.in(CompanyInfo::getCode, companyCode));
        Map<String, String> companyInfoMap = companyInfoList.stream().collect(Collectors.toMap(CompanyInfo::getCode, CompanyInfo::getName));

        List<Long> ids = lsit.stream().map(DeliverGoods::getId).collect(Collectors.toList());
        List<DeliverGoodsDetailsVo> list = deliverGoodsDetailsService.getList(IWrapper.<DeliverGoodsDetails>getWrapper().in(DeliverGoodsDetails::getDeliverGoodsId, ids));
        Map<Long, List<DeliverGoodsDetailsVo>> collect = list.stream().collect(Collectors.groupingBy(DeliverGoodsDetails::getDeliverGoodsId));
        for (DeliverGoodsVo deliverGoods : lsit) {
            deliverGoods.setDeliverGoodsDetailsList(collect.getOrDefault(deliverGoods.getId(), new ArrayList<>()));

            deliverGoods.setLogisticsCompanyName(companyInfoMap.get(deliverGoods.getLogisticsCompanyCode()));
        }
    }

    @Override
    public List<DeliverGoodsDetailsVo> detail(Long id) {
        Assert.notEmpty(id, "发货id不能为空");
//        DeliverGoods deliverGoods = this.getById(id);
//        DeliverGoodsVo deliverGoodsVo = BeanUtil.copyProperties(deliverGoods, DeliverGoodsVo.class);

        //根据发货id查发货明细
        IWrapper<DeliverGoods> wrapper = IWrapper.getWrapper();
        wrapper.eq("dgd.deliver_goods_id", id);
        wrapper.eq("dg.status", 0);
        List<DeliverGoodsDetailsVo> deliverGoodsDetailsVos = baseMapper.listDeliverGoodsDetails(wrapper);
        //获取采购明细列表
        //赋值产品信息
        List<Long> pdids = deliverGoodsDetailsVos.stream().map(DeliverGoodsDetails::getPurchaseDetailId).collect(Collectors.toList());
        if (ObjectUtil.isEmpty(pdids)) {
            return deliverGoodsDetailsVos;
        }
        List<PurchaseDetail> purchaseDetailList = purchaseDetailService.listByIds(pdids);
        Map<Long, Long> goodidmap = purchaseDetailList.stream().collect(Collectors.toMap(PurchaseDetail::getId, PurchaseDetail::getBussinessId));
        List<Long> goodids = purchaseDetailList.stream().map(PurchaseDetail::getBussinessId).collect(Collectors.toList());
        List<ProductInfo> productInfos = productInfoService.listByIds(goodids);
        Map<Long, ProductInfo> productInfoMap = productInfos.stream().collect(Collectors.toMap(ProductInfo::getId, Function.identity()));
        //获取采购明细信息
        Map<Long, PurchaseDetail> purchaseDetailMap = purchaseDetailList.stream().collect(Collectors.toMap(PurchaseDetail::getId, Function.identity()));

        for (DeliverGoodsDetailsVo deliverGoodsDetailsVo : deliverGoodsDetailsVos) {
            //赋值产品信息
            Long goodid = goodidmap.get(deliverGoodsDetailsVo.getPurchaseDetailId());
            ProductInfo productInfo = productInfoMap.get(goodid);
            if (ObjectUtil.isNotEmpty(productInfo)) {
                deliverGoodsDetailsVo.setProductId(productInfo.getId());
                deliverGoodsDetailsVo.setType(productInfo.getType());
                deliverGoodsDetailsVo.setCode(productInfo.getCode());
                deliverGoodsDetailsVo.setName(productInfo.getName());
                deliverGoodsDetailsVo.setSpec(productInfo.getSpec());
                deliverGoodsDetailsVo.setUnit(productInfo.getUnit());
                deliverGoodsDetailsVo.setDefinition(productInfo.getDefinition());
            }
            //赋值采购数量
            PurchaseDetail purchaseDetail = purchaseDetailMap.get(deliverGoodsDetailsVo.getPurchaseDetailId());
            deliverGoodsDetailsVo.setCount(purchaseDetail.getCount());
            //赋值在途数量
            IWrapper<DeliverGoods> wrapper1 = IWrapper.getWrapper();
            wrapper1.eq("dgd", DeliverGoodsDetails::getPurchaseDetailId, deliverGoodsDetailsVo.getPurchaseDetailId());
            wrapper1.eq("dg.status", 0);
            List<DeliverGoodsDetailsVo> list = baseMapper.listDeliverGoodsDetails(wrapper1);
            BigDecimal count = list.stream()
                    .map(DeliverGoodsDetails::getDeliverGoodsQuantity)
                    .reduce(BigDecimal.ZERO, BigDecimal::add);
            BigDecimal subtract = count.subtract(deliverGoodsDetailsVo.getDeliverGoodsQuantity());
            deliverGoodsDetailsVo.setTransitQuantity(subtract);
        }

//        deliverGoodsVo.setDeliverGoodsDetailsList(deliverGoodsDetailsVos);
        return deliverGoodsDetailsVos;
    }

    @DSTransactional
    @Override
    public void add(DeliverGoodsDto deliverGoodsDto) {
        deliverGoodsDto.setStatus(0);//设置未到货
        this.save(deliverGoodsDto);

        //获取采购信息
        Purchase purchase = purchaseService.getById(deliverGoodsDto.getPurchaseId());
        //创建物流信息
        LogisticsInfos logisticsInfos = new LogisticsInfos();
        logisticsInfos.setId(IdWorker.getId());
        logisticsInfos.setBusinessId(deliverGoodsDto.getId());//设置业务id为发货id
//        logisticsInfos.setBusinessCode(purchase.getCode());//设置采购单号为业务单号
        String victoriatouristJson2 = purchase.getVictoriatouristJson();
        JSONObject json2 = ObjectUtil.isNotEmpty(victoriatouristJson2) ? JSONObject.parseObject(victoriatouristJson2) : new JSONObject();
        logisticsInfos.setBusinessCode(json2.getString("contractCode"));
        logisticsInfos.setBusinessType(1);//采购到货
        logisticsInfos.setStatus(0);
        logisticsInfos.setInStockStatus(10);
        logisticsInfos.setCode(deliverGoodsDto.getCode());
        logisticsInfos.setLogisticsCompanyCode(deliverGoodsDto.getLogisticsCompanyCode());
        logisticsInfos.setIsKd100(0);
        logisticsInfos.setPurchaseId(purchase.getId());
        logisticsInfos.setPhone(deliverGoodsDto.getPhone());

        //发起快递100订阅
        DynamicDataSourceContextHolder.push(SourceConstant.KD100);
        //只在生产环境调用Kd100
        String activeProfile = SpringUtil.getActiveProfile();
        Integer state = !"prod".equals(activeProfile) ? -1 : KD100Util.monitor(logisticsInfos.getLogisticsCompanyCode(), logisticsInfos.getCode(), logisticsInfos.getPhone(), logisticsInfos.getId(), 1, LogisticsInfos.class).getState();
        DynamicDataSourceContextHolder.poll();
        logisticsInfos.setIsKd100(1);
        logisticsInfos.setLogisticsStatus(state);
        logisticsInfos.setDeliverGoodsId(deliverGoodsDto.getId());

        logisticsInfosService.save(logisticsInfos);

        List<DeliverGoodsDetails> deliverGoodsDetailsList = deliverGoodsDto.getDeliverGoodsDetailsList();
        List<LogisticsDetails> logisticsDetailsList = new ArrayList<>();

        for (DeliverGoodsDetails deliverGoodsDetails : deliverGoodsDetailsList) {
            deliverGoodsDetails.setId(IdWorker.getId());

            PurchaseDetail byId = purchaseDetailService.getById(deliverGoodsDetails.getPurchaseDetailId());
            deliverGoodsDetails.setProductId(byId.getBussinessId());

            deliverGoodsDetails.setDeliverGoodsId(deliverGoodsDto.getId());

            LogisticsDetails logisticsDetails = new LogisticsDetails();
            logisticsDetails.setBusinessDetailsId(deliverGoodsDetails.getId());//设置发货明细id为业务id
            logisticsDetails.setLogisticsInfoId(logisticsInfos.getId());
            logisticsDetails.setPurchaseId(purchase.getId());
            logisticsDetails.setPurchaseDetailsId(deliverGoodsDetails.getPurchaseDetailId());
            logisticsDetails.setShipmentQuantity(deliverGoodsDetails.getDeliverGoodsQuantity());
            logisticsDetails.setDeliverGoodsDetailsId(deliverGoodsDetails.getId());
            logisticsDetailsList.add(logisticsDetails);
        }
        deliverGoodsDetailsService.saveBatch(deliverGoodsDetailsList);
        logisticsDetailsService.saveBatch(logisticsDetailsList);
    }

    @Override
    @DSTransactional
    public void edit(DeliverGoodsDto deliverGoodsDto) {
        this.updateById(deliverGoodsDto);

        LogisticsInfos logisticsInfos = logisticsInfosService.getOne(q -> q.eq(LogisticsInfos::getBusinessId, deliverGoodsDto.getId())
                .or().eq(LogisticsInfos::getDeliverGoodsId, deliverGoodsDto.getId()));

        //发起快递100订阅
        DynamicDataSourceContextHolder.push(SourceConstant.KD100);
        //只在生产环境调用Kd100
        String activeProfile = SpringUtil.getActiveProfile();
        Integer state = !"prod".equals(activeProfile) ? -1 : KD100Util.monitor(deliverGoodsDto.getLogisticsCompanyCode(), deliverGoodsDto.getCode(), deliverGoodsDto.getPhone(), logisticsInfos.getId(), 1, LogisticsInfos.class).getState();
        DynamicDataSourceContextHolder.poll();

        logisticsInfos.setLogisticsCompanyCode(deliverGoodsDto.getLogisticsCompanyCode());
        logisticsInfos.setCode(deliverGoodsDto.getCode());
        logisticsInfos.setSubCode(deliverGoodsDto.getSubCode());
        logisticsInfos.setStatus(state);

        logisticsInfosService.updateById(logisticsInfos);

    }

    @Override
    public void delete(Long id) {
        this.removeById(id);
    }

    @Override
    public List<DeliverGoodsVo> list(Long id) {
        //根据采购id查发货列表
        List<DeliverGoodsVo> list = baseMapper.getList(IWrapper.getWrapper().eq("dg", DeliverGoods::getPurchaseId, id).eq("dg", DeliverGoods::getStatus, 0));
        return list;
    }

    @Override
    public PurchaseVo arrivalDetail(Long purchaseId) {
        Purchase purchase = purchaseService.getById(purchaseId);
        PurchaseVo result = BeanUtil.toBean(purchase, PurchaseVo.class);

        // 赋值供应商名称
        setSupplyName(result, purchase.getSupplyId());

        //赋值采购明细
        DynamicDataSourceContextHolder.push(SourceConstant.PURCHASE);
        List<PurchaseDetailVo> purchaseDetailVoList = purchaseDetailMapper.getList(IWrapper.<PurchaseDetail>getWrapper()
                .eq(PurchaseDetail::getPurchaseId, purchase.getId())
                .orderByAsc("pi.name")
        );
        DynamicDataSourceContextHolder.poll();

        // 赋值质检信息
        setQualityInfo(purchaseId, purchaseDetailVoList);

        // 赋值发货信息
        List<DeliverGoodsDetailsVo> list = setDeliverGoodsInfo(purchaseId, purchaseDetailVoList);

        // 赋值到货信息
        setArrivalDetailInfo(purchaseId, purchaseDetailVoList, list);

        // 赋值退货信息
        setPurchaseBackInfo(purchaseId, purchaseDetailVoList);

        // 赋值已入库记录
        setWarehousingInfo(purchaseDetailVoList, list);

        result.setPurchaseDetailVoList(purchaseDetailVoList);
        return result;
    }

    @Override
    public List<DeliverGoodsDetailsVo> listDeliverGoodsDetails(IWrapper<DeliverGoods> wrapper) {
        return baseMapper.listDeliverGoodsDetails(wrapper);
    }

    /**
     * 赋值供应商名称
     */
    private void setSupplyName(PurchaseVo result, Long supplyId) {
        SupplierInfo supplierInfo = supplierInfoService.getById(supplyId);
        if (ObjectUtil.isNotEmpty(supplierInfo)) {
            result.setSupplyName(supplierInfo.getName());
        }
    }

    /**
     * 赋值质检信息
     */
    private void setQualityInfo(Long purchaseId, List<PurchaseDetailVo> purchaseDetailVoList) {

        List<QualityDetailVo> qualityDetailVoList = baseMapper.getQualityInfoByPurchaseId(purchaseId);

        if (ObjectUtil.isEmpty(qualityDetailVoList)) {
            return;
        }

        //赋值质检人名称
        UserUtil.assignmentNickName(qualityDetailVoList, QualityDetailVo::getCreateUser, QualityDetailVo::setCreateUserName);

        Map<Long, List<QualityDetailVo>> qualityDetailsMap = qualityDetailVoList.stream()
                .collect(Collectors.groupingBy(QualityDetailVo::getPurchaseDetailId));

        for (PurchaseDetailVo purchaseDetailVo : purchaseDetailVoList) {

            //根据产品id获取质检信息
            List<QualityDetailVo> qualityDetails = qualityDetailsMap.get(purchaseDetailVo.getId());

            if (ObjectUtil.isEmpty(qualityDetails)) {
                purchaseDetailVo.setQualifiedCount(BigDecimal.ZERO);
                purchaseDetailVo.setNoQualifiedCount(BigDecimal.ZERO);
                purchaseDetailVo.setQualityQuantity(BigDecimal.ZERO);
                continue;
            }

            BigDecimal qualifiedCount = qualityDetails.stream().map(QualityDetail::getQualifiedCount).reduce(BigDecimal.ZERO, BigDecimal::add);
            BigDecimal noQualifiedCount = qualityDetails.stream().map(QualityDetail::getNoQualifiedCount).reduce(BigDecimal.ZERO, BigDecimal::add);

            //赋值质检之和
            purchaseDetailVo.setQualifiedCount(qualifiedCount);
            purchaseDetailVo.setNoQualifiedCount(noQualifiedCount);
            purchaseDetailVo.setQualityQuantity(qualifiedCount.add(noQualifiedCount));
            purchaseDetailVo.setIsReject(noQualifiedCount.compareTo(BigDecimal.ZERO) > 0 ? 1 : 0);

            //过滤调质检数为0的明细数据 留下有质检数的数据
            qualityDetails = qualityDetails.stream()
                    .filter(item -> item.getQualifiedCount().add(item.getNoQualifiedCount()).compareTo(BigDecimal.ZERO) != 0)
                    .collect(Collectors.toList());

            //赋值产品质检的明细
            purchaseDetailVo.setQualityDetailsList(qualityDetails);
        }
    }

    /**
     * 赋值发货信息
     */
    private List<DeliverGoodsDetailsVo> setDeliverGoodsInfo(Long purchaseId, List<PurchaseDetailVo> purchaseDetailVoList) {

        IWrapper<DeliverGoods> wrapper = getWrapper();
        wrapper.eq("dg", DeliverGoods::getPurchaseId, purchaseId);
        List<DeliverGoodsDetailsVo> list = baseMapper.listDeliverGoodsDetails(wrapper);

        if (ObjectUtil.isEmpty(list)) {
            return list;
        }

        Map<Long, List<DeliverGoodsDetailsVo>> deliverGoodsDetailsVoMap = list.stream()
                .collect(Collectors.groupingBy(DeliverGoodsDetailsVo::getPurchaseDetailId));

        for (PurchaseDetailVo purchaseDetailVo : purchaseDetailVoList) {

            List<DeliverGoodsDetailsVo> itemList = deliverGoodsDetailsVoMap.get(purchaseDetailVo.getId());

            if (ObjectUtil.isEmpty(itemList)) {
                purchaseDetailVo.setDeliverGoodsQuantity(BigDecimal.ZERO);
                continue;
            }

            //发货数量求和
            BigDecimal dgdCount = itemList.stream()
                    .map(DeliverGoodsDetailsVo::getDeliverGoodsQuantity)
                    .reduce(BigDecimal.ZERO, BigDecimal::add);

            purchaseDetailVo.setDeliverGoodsQuantity(dgdCount);
            purchaseDetailVo.setDeliverGoodsDetailList(BeanUtil.copyToList(itemList, DeliverGoodsDetailsPoVo.class));
        }

        return list;
    }

    /**
     * 赋值到货信息
     */
    private void setArrivalDetailInfo(Long purchaseId, List<PurchaseDetailVo> purchaseDetailVoList, List<DeliverGoodsDetailsVo> list) {
        IWrapper<ArrivalDetail> wrapper = arrivalDetailService.getWrapper();
        wrapper.eq("a.purchase_id", purchaseId);
        List<ArrivalDetailVo> arrivalDetail = arrivalDetailService.getArrivalDetail(wrapper);

        if (ObjectUtil.isEmpty(arrivalDetail)) {
            return;
        }

        Map<Long, List<ArrivalDetailVo>> collect = arrivalDetail.stream().collect(Collectors.groupingBy(ArrivalDetailVo::getPurchaseDetailId));

        Map<Long, String> dgdMap = list.stream().collect(Collectors.toMap(DeliverGoodsDetailsVo::getId, DeliverGoodsDetailsVo::getLogisticsCode));
        for (PurchaseDetailVo purchaseDetailVo : purchaseDetailVoList) {
            List<ArrivalDetailVo> list1 = collect.get(purchaseDetailVo.getId());
            if (ObjectUtil.isEmpty(list1)) {
                purchaseDetailVo.setArrivalQuantity(BigDecimal.ZERO);
                continue;
            }

            //赋值发货单号
            for (ArrivalDetailVo arrivalDetailVo : list1) {
                arrivalDetailVo.setLogisticsCode(dgdMap.get(arrivalDetailVo.getDeliverGoodsDetailsId()));
            }

            //到货数量求和
            BigDecimal arrCount = list1.stream()
                    .map(ArrivalDetailVo::getCount)
                    .reduce(BigDecimal.ZERO, BigDecimal::add);
            purchaseDetailVo.setArrivalQuantity(arrCount);
            purchaseDetailVo.setArrivalDetailList(list1);
        }
    }

    /**
     * 赋值退货信息
     */
    private void setPurchaseBackInfo(Long purchaseId, List<PurchaseDetailVo> purchaseDetailVoList) {
        List<PurchaseBack> list = purchaseBackService.list(q -> q.eq(PurchaseBack::getPurchaseId, purchaseId));

        if (ObjectUtil.isEmpty(list)) {
            return;
        }

        List<Long> ids = list.stream().map(PurchaseBack::getId).collect(Collectors.toList());
        Map<Long, List<PurchaseBackDetails>> longListMap = purchaseBackDetailsService.mapKGroup(PurchaseBackDetails::getPurchaseDetailsId, q -> q.in(PurchaseBackDetails::getPurchaseBackId, ids));

        //赋值已退货数量（已经出库的数量）
        List<Long> pbdIds = longListMap.values().stream().flatMap(Collection::stream).map(PurchaseBackDetails::getId).collect(Collectors.toList());

        Map<Long, StockWaitDetails> stockWaitDetailsMap = stockWaitDetailsService.mapKEntity(StockWaitDetails::getBusinessDetailsId,
                q -> q.in(StockWaitDetails::getBusinessDetailsId, pbdIds));

        for (PurchaseDetailVo purchaseDetailVo : purchaseDetailVoList) {
            List<PurchaseBackDetails> purchaseBackDetails = longListMap.get(purchaseDetailVo.getId());
            List<PurchaseBackDetailsVo> purchaseBackDetailsVos = BeanUtil.copyToList(purchaseBackDetails, PurchaseBackDetailsVo.class);

            if (ObjectUtil.isEmpty(purchaseBackDetailsVos)) {
                purchaseDetailVo.setPurchaseBackQuantity(BigDecimal.ZERO);
                continue;
            }

            //退货数量求和
            BigDecimal backCount = purchaseBackDetailsVos.stream()
                    .map(PurchaseBackDetails::getQuantity)
                    .reduce(BigDecimal.ZERO, BigDecimal::add);
            purchaseDetailVo.setPurchaseBackQuantity(backCount);

            //已退数量
            BigDecimal returnedQuantityCount = BigDecimal.ZERO;

            for (PurchaseBackDetailsVo purchaseBackDetailsVo : purchaseBackDetailsVos) {
                StockWaitDetails stockWaitDetails = stockWaitDetailsMap.get(purchaseBackDetailsVo.getId());
                BigDecimal returnedQuantity = BigDecimal.ZERO;
                if (ObjectUtil.isNotEmpty(stockWaitDetails)) {
                    returnedQuantity = stockWaitDetails.getReceiptQuantity();
                }
                returnedQuantityCount = returnedQuantityCount.add(returnedQuantity);
                purchaseBackDetailsVo.setReturnedQuantity(returnedQuantity);
            }

            purchaseDetailVo.setPurchaseReturnedQuantity(returnedQuantityCount);
            purchaseDetailVo.setPurchaseBackDetailsList(purchaseBackDetailsVos);
        }

    }

    private void setWarehousingInfo(List<PurchaseDetailVo> purchaseDetailVoList, List<DeliverGoodsDetailsVo> list) {

        if (purchaseDetailVoList.isEmpty()) {
            return;
        }

        //对入库已入库列表赋值发货单号
        Map<Long, String> dgdMap = list.stream().collect(Collectors.toMap(DeliverGoodsDetailsVo::getId, DeliverGoodsDetailsVo::getLogisticsCode));

        Set<Long> idSet = purchaseDetailVoList.stream().map(BaseIdPo::getId).collect(Collectors.toSet());
        List<ArrivalDetail> arrivalDetailList = arrivalDetailService.list(q -> q.in(ArrivalDetail::getPurchaseDetailId, idSet));
        Map<Long, List<ArrivalDetail>> arrivalDetailMap = arrivalDetailList.stream().collect(Collectors.groupingBy(ArrivalDetail::getPurchaseDetailId));

        Set<Long> arrivalDetailIdSet = arrivalDetailList.stream().map(BaseIdPo::getId).collect(Collectors.toSet());
        List<StockWaitDetails> stockWaitDetailsList = arrivalDetailIdSet.isEmpty() ? Collections.emptyList()
                : stockWaitDetailsService.list(q -> q.in(StockWaitDetails::getBusinessDetailsId, arrivalDetailIdSet));

        Set<Long> stockWaitIdSet = stockWaitDetailsList.stream().map(StockWaitDetails::getStockWaitId).collect(Collectors.toSet());
        List<StockJournal> stockJournalList = stockWaitIdSet.isEmpty() ? Collections.emptyList()
                : stockJournalService.list(q -> q.in(StockJournal::getBusinessId, stockWaitIdSet));

        Set<Long> stockWaitDetailsIdSet = stockWaitDetailsList.stream().map(BaseIdPo::getId).collect(Collectors.toSet());
        List<StockJournalDetails> stockJournalDetailsList = stockWaitDetailsIdSet.isEmpty() ? Collections.emptyList()
                : stockJournalDetailsService.list(q -> q.in(StockJournalDetails::getBusinessDetailsId, stockWaitDetailsIdSet));

        //Set<Long> stockJournalIdSet = stockJournalDetailsList.stream().map(StockJournalDetails::getStockJournalId).collect(Collectors.toSet());
        //List<StockJournal> stockJournalList1 = stockJournalService.list(q -> q.in(StockJournal::getId, stockJournalIdSet));

        Map<Long, StockJournal> stockJournalMap = stockJournalList.stream().collect(Collectors.toMap(StockJournal::getId, item -> item));

        Map<Long, Map<Long, StockWaitDetails>> stockWaitDetailsMap = stockWaitDetailsList.stream()
                .collect(Collectors.groupingBy(StockWaitDetails::getStockWaitId,
                        Collectors.toMap(StockWaitDetails::getProductId, item -> item, (v1, v2) -> v1)));

        Map<Long, ArrivalDetail> arrivalDetailIdMap = arrivalDetailList.stream().collect(Collectors.toMap(BaseIdPo::getId, item -> item));

        List<ArrivalStockRecordsDetails> arrivalStockRecordsDetailsList = stockWaitDetailsIdSet.isEmpty() ? Collections.emptyList()
                : arrivalStockRecordsDetailsService.list(q -> q.in(ArrivalStockRecordsDetails::getBusinessDetailsId, stockWaitDetailsIdSet));
        Map<Long, List<ArrivalStockRecordsDetails>> arrivalStockRecordsDetailsMap = arrivalStockRecordsDetailsList.stream()
                .collect(Collectors.groupingBy(ArrivalStockRecordsDetails::getBusinessDetailsId));

        Set<Long> arrivalStockRecordsDetailsIdSet = arrivalStockRecordsDetailsList.stream().map(ArrivalStockRecordsDetails::getId).collect(Collectors.toSet());
        List<QualityDetails> qualityDetailsList = arrivalStockRecordsDetailsIdSet.isEmpty() ? Collections.emptyList()
                : qualityDetailsService.list(q -> q.in(QualityDetails::getArrivalStockRecordsDetailsId, arrivalStockRecordsDetailsIdSet));

        for (PurchaseDetailVo purchaseDetailVo : purchaseDetailVoList) {

            //根据采购明细id查到货明细
            List<ArrivalDetail> tempArrivalDetailList = arrivalDetailMap.get(purchaseDetailVo.getId());
            if (ObjectUtil.isEmpty(tempArrivalDetailList)) {
                continue;
            }

            //根据到货明细id查待入库明细
            Set<Long> arrivalDetailIds = tempArrivalDetailList.stream().map(ArrivalDetail::getId).collect(Collectors.toSet());
            List<StockWaitDetails> tempStockWaitDetailsList = stockWaitDetailsList.stream()
                    .filter(item -> arrivalDetailIds.contains(item.getBusinessDetailsId()))
                    .collect(Collectors.toList());
            if (ObjectUtil.isEmpty(tempStockWaitDetailsList)) {
                continue;
            }

            //根据待入库id查出入库记录
            List<Long> stockWaitIds = tempStockWaitDetailsList.stream().map(StockWaitDetails::getStockWaitId).collect(Collectors.toList());
            List<Long> stockJournalIds = stockJournalList.stream()
                    .filter(item -> stockWaitIds.contains(item.getBusinessId()))
                    .map(StockJournal::getId)
                    .collect(Collectors.toList());
            if (ObjectUtil.isEmpty(stockJournalIds)) {
                continue;
            }

            //查出产品的出入库明细
            List<Long> swdIds = tempStockWaitDetailsList.stream().map(StockWaitDetails::getId).collect(Collectors.toList());
            List<StockJournalDetailsVo> stockJournalDetailsVos = stockJournalDetailsList.stream()
                    .filter(item -> swdIds.contains(item.getBusinessDetailsId()))
                    .map(item -> BeanUtil.toBean(item, StockJournalDetailsVo.class))
                    .collect(Collectors.toList());

            if (ObjectUtil.isEmpty(stockJournalDetailsVos)) {
                continue;
            }

            for (StockJournalDetailsVo stockJournalDetailsVo : stockJournalDetailsVos) {

                StockJournal stockJournal = stockJournalMap.get(stockJournalDetailsVo.getStockJournalId());

                StockWaitDetails stockWaitDetails = stockWaitDetailsMap.get(stockJournal.getBusinessId()).get(stockJournalDetailsVo.getProductId());

                Long businessDetailsId = stockWaitDetails.getBusinessDetailsId();
                ArrivalDetail arrivalDetail1 = arrivalDetailIdMap.get(businessDetailsId);

                //赋值发货单号
                stockJournalDetailsVo.setLogisticsCode(dgdMap.get(arrivalDetail1.getDeliverGoodsDetailsId()));

                //赋值是否有次品
                stockJournalDetailsVo.setIsReject(0);

                List<ArrivalStockRecordsDetails> tempArrivalStockRecordsDetailsList = arrivalStockRecordsDetailsMap.get(stockWaitDetails.getId());

                if (ObjectUtil.isNotEmpty(tempArrivalStockRecordsDetailsList)) {

                    List<Long> ids = tempArrivalStockRecordsDetailsList.stream().map(ArrivalStockRecordsDetails::getId).collect(Collectors.toList());

                    BigDecimal noQualityCount = qualityDetailsList.stream()
                            .filter(item -> ids.contains(item.getArrivalStockRecordsDetailsId()))
                            .map(QualityDetails::getDisqualificationQuantity)
                            .reduce(BigDecimal.ZERO, BigDecimal::add);

                    if (noQualityCount.compareTo(BigDecimal.ZERO) > 0) {
                        stockJournalDetailsVo.setIsReject(1);
                    }

                }

                //赋值入库状态
                stockJournalDetailsVo.setReceiptStatus(1);//部分入库

                if (stockWaitDetails.getReceiptQuantity().compareTo(stockWaitDetails.getQuantity()) >= 0) {
                    stockJournalDetailsVo.setReceiptStatus(2);//完全入库
                }

            }

            //对数量求和
            BigDecimal receiptQuantity = stockJournalDetailsVos.stream()
                    .map(StockJournalDetails::getQuantity)
                    .reduce(BigDecimal.ZERO, BigDecimal::add);

            //赋值数量和记录
            purchaseDetailVo.setReceiptQuantity(receiptQuantity);
            purchaseDetailVo.setReceiptList(stockJournalDetailsVos);
        }
    }

}
