package com.fjhx.wms.controller.stock;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.wms.entity.stock.dto.StockWaitDetailsCheckDto;
import com.fjhx.wms.entity.stock.dto.StockWaitDetailsCheckSelectDto;
import com.fjhx.wms.entity.stock.vo.StockWaitDetailsCheckVo;
import com.fjhx.wms.service.stock.StockWaitDetailsCheckService;
import com.ruoyi.common.core.domain.BaseSelectDto;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * <p>
 * 待入库清点 前端控制器
 * </p>
 *
 * @author
 * @since 2024-03-25
 */
@RestController
@RequestMapping("/stockWaitDetailsCheck")
public class StockWaitDetailsCheckController {

    @Autowired
    private StockWaitDetailsCheckService stockWaitDetailsCheckService;

    /**
     * 待入库清点列表
     */
    @PostMapping("/list")
    public List<StockWaitDetailsCheckVo> list(@RequestBody StockWaitDetailsCheckSelectDto dto) {
        return stockWaitDetailsCheckService.getList(dto);
    }

    /**
     * 待入库清点分页
     */
    @PostMapping("/page")
    public Page<StockWaitDetailsCheckVo> page(@RequestBody StockWaitDetailsCheckSelectDto dto) {
        return stockWaitDetailsCheckService.getPage(dto);
    }

    /**
     * 待入库清点明细
     */
    @PostMapping("/detail")
    public StockWaitDetailsCheckVo detail(@RequestBody BaseSelectDto dto) {
        return stockWaitDetailsCheckService.detail(dto.getId());
    }

    /**
     * 待入库清点新增
     */
    @PostMapping("/add")
    public void add(@RequestBody StockWaitDetailsCheckDto stockWaitDetailsCheckDto) {
        stockWaitDetailsCheckService.add(stockWaitDetailsCheckDto);
    }

    /**
     * 待入库清点编辑
     */
    @PostMapping("/edit")
    public void edit(@RequestBody StockWaitDetailsCheckDto stockWaitDetailsCheckDto) {
        stockWaitDetailsCheckService.edit(stockWaitDetailsCheckDto);
    }

    /**
     * 待入库清点删除
     */
    @PostMapping("/delete")
    public void delete(@RequestBody BaseSelectDto dto) {
        stockWaitDetailsCheckService.delete(dto.getId());
    }

}
