package com.fjhx.wms.entity.stock.emums;

import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.HashMap;
import java.util.Map;

@AllArgsConstructor
@Getter
public enum JournalType {
    MANUAL_IN(InOutType.IN, 1, "手动入库", ""),
    MANUAL_OUT(InOutType.OUT, 2, "手动出库", ""),
    ADJUSTING_IN(InOutType.IN, 3, "调仓入库", ""),
    //    STOCK_WAIT_IN(InOutType.IN, 4, "待入库入库", "stock_wait"),
//    STOCK_WAIT_OUT(InOutType.OUT, 5, "待出库出库", "stock_wait"),
    COMBINATION_IN(InOutType.IN, 6, "组合入库", "group_record_details"),
    COMBINATION_OUT(InOutType.OUT, 7, "组合出库", "group_record_details"),
    SPLIT_IN(InOutType.IN, 8, "组合拆分入库", "group_record_details"),
    SPLIT_OUT(InOutType.OUT, 9, "组合拆分出库", "group_record_details"),
    JD_SALES_OUT(InOutType.OUT, 10, "京东销售出库", "sales_record"),
    ADJUSTING_OUT(InOutType.OUT, 11, "调仓出库", ""),
    SALES_OUT(InOutType.OUT, 12, "销售订单出库", ""),
    BACK_OUT(InOutType.OUT, 13, "待出库 退货出库", ""),
    ARRIVAL_IN(InOutType.IN, 14, "到货入库", ""),
    JD_BACK_IN(InOutType.IN, 15, "京东退货入库", ""),


    BORDER_OF_LINE_IN(InOutType.IN, 16, "待入库 线边回仓", ""),
    COMPLETION_IN(InOutType.IN, 17, "待入库 完工入库", ""),
    PURCHASE_ARRIVAL_IN(InOutType.IN, 18, "待入库 采购到货", ""),
    ARRIVAL_QUALITY(InOutType.IN, 19, "到货质检", "quality_info"),
    PRODUCTION_TASK_OUT(InOutType.OUT, 20, "生产任务待出库出库", "production_task"),
    QUALIFIED_TO_DEFECTIVE(InOutType.IN, 21, "良品转次品", "stock"),
    DEFECTIVE_TO_QUALIFIED(InOutType.IN, 22, "次品转良品", "stock"),

    EXCESS_GOODS_IN(InOutType.IN, 23, "多货入库", ""),


    JDYC_DFBDCK(InOutType.OUT, 1000, "（京东异常）多发：补单出库", ""),
    JDYC_SFTHRK(InOutType.IN, 2000, "（京东异常）少发：退回入库", ""),
    JDYC_CFBDCK(InOutType.OUT, 3000, "（京东异常）错发：补单出库", ""),
    JDYC_CFTHRK(InOutType.IN, 4000, "（京东异常）错发：退回入库", ""),
    JDYC_CFBSCK(InOutType.OUT, 5000, "（京东异常）错发：报损出库", ""),
    JDYC_TMCWTHRk(InOutType.IN, 6000, "（京东异常）条码错误：退回入库", "");


    private static final Map<Integer, String> map = new HashMap<>();

    static {
        for (JournalType journalType : JournalType.values()) {
            map.put(journalType.getDetailType(), journalType.getDetailTypeRemark());
        }
    }

    /**
     * 出入库类型
     */
    private final InOutType type;
    /**
     * 详细类型
     */
    private final Integer detailType;
    /**
     * 信息类型说明
     */
    private final String detailTypeRemark;
    /**
     * 关联业务表名
     */
    private final String linkBusinessTableName;

    public static String getJournalTypeVal(Integer type) {
        return map.get(type);
    }

}
