package com.fjhx.wms.entity.stock.emums;

import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.HashMap;

@AllArgsConstructor
@Getter
public enum StockWaitType {

    // BORDER_OF_LINE_IN(InOutType.IN,JournalType.BORDER_OF_LINE_IN, 1, "线边回仓", ""),
    // COMPLETION_IN(InOutType.IN,JournalType.COMPLETION_IN, 2, "完工入库", ""),
    PURCHASE_ARRIVAL_IN(InOutType.IN, JournalType.PURCHASE_ARRIVAL_IN, 3, "采购到货", ""),
    BACK_OUT(InOutType.OUT, JournalType.BACK_OUT, 4, "退货出库", ""),
    JD_ORDER_OUT(InOutType.OUT, JournalType.JD_SALES_OUT, 5, "京东订单出库", "jd_order"),
    SALE_ORDER_OUT(InOutType.OUT, JournalType.SALES_OUT, 6, "销售订单出库", "order_info"),
    // PRODUCTION_TASK_OUT(InOutType.OUT, 7, "生产任务待出库", "production_task"),
    EXCESS_GOODS_IN(InOutType.IN, JournalType.EXCESS_GOODS_IN, 23, "多货入库", "production_task");

    private static final HashMap<String, StockWaitType> hashMap = new HashMap<>();

    static {
        for (StockWaitType value : StockWaitType.values()) {
            hashMap.put(String.valueOf(value.detailType), value);
        }
    }

    /**
     * 出入库类型
     */
    private final InOutType type;
    private final JournalType journalType;
    /**
     * 详细类型
     */
    private final Integer detailType;
    /**
     * 信息类型说明
     */
    private final String detailTypeRemark;
    /**
     * 关联业务表名
     */
    private final String linkBusinessTableName;

    public static String getEnum(String code) {
        return hashMap.get(code).getDetailTypeRemark();
    }

    public static StockWaitType getEnum1(String detailType) {
        return hashMap.get(detailType);
    }

}
